QGIS Application - Bug report #20591
Dissolve tool failing to produce outputs
2018-11-22 11:44 AM - Andy Harfoot

Status: Closed

Priority: Normal

Assignee: Alessandro Pasotti

Category: Processing/QGIS

Affected QGIS version:3.4.1 Regression?: No

Operating System: Win 10 x64 Easy fix?: No

Pull Request or Patch supplied: Resolution: fixed/implemented
Crashes QGIS or corrupls data: Copied to github as #: 28411
Description

I'm seeing very strange behaviour with a particular shapefile in QGIS 3.4.1. The data is attached

When | run the Vector Geometry > Dissolve Processing tool on it, no errors are raised, an output layer is created containing one row with

no geometry. This happens regardless of the Processing 'Invalid features filtering' setting.

Running the GDAL > Vector geoprocessing > Dissolve tool on the data immediately returns an invalid geometry (self intersection) error,
but running Vector Geometry > Check validity finds no errors using either the GEOS or QGIS engine. The ArcGIS Check Geometry tool

also fails to find any errors.

If the Vector Geometry > Dissolve tool is run on a selection from the shapefile, it will complete successfully if all but one feature is

selected, regardless of which feature is left unselected.

History

#1 - 2018-11-22 11:47 AM - Andy Harfoot

The dissolve works fine using the corresponding tool in 2.18.15

#2 - 2018-11-22 02:31 PM - Alessandro Pasotti

- File qgis-dissolve-error.png added

- Status changed from Open to In Progress

- Assignee set to Alessandro Pasotti

Ok, first step was to show the error message (see attached).

Second step is to understand if the error message (which comes from GEOS library) makes sense.

#3 - 2018-11-22 02:36 PM - Alessandro Pasotti
- Resolution set to up/downstream
- File qgis-dissolve-error-2.png added

Looks like the problem is in the GEOS library... I'm using GEOS 3.5.1.

| would be in favor of closing as upstream.
#4 - 2018-11-22 02:45 PM - Andy Harfoot

Both my QGIS 3.4.1 and 2.18.15 use an identical version of GEOS (3.7.0-CAPI-1.11.0), yet the dissolve completes in 2.18 but not in 3.4.

#5 - 2018-11-22 02:46 PM - Andy Harfoot

Does GDAL share the GEOS library in a QGIS install, or have its own copy? The QGIS processing dissolve tool does not produce an error, nor any output,

but the GDAL tool produces the GEOS error that is in the screenshot, could this be due to a different version being used?

#6 - 2018-11-22 02:57 PM - Alessandro Pasotti

I'm not an expert about windows, but I'm pretty sure that GDAL and QGIS use exactly the same shared GEOS library.

The error message was not shown in 3.4 QGIS Dissolve algorithm (I'm going to fix that) but the error was thrown from GEOS and it was visible in the debug
log.

It's wierd that it worked in 2.18, I'll check it, but it is also possible that in 2.18 the algorithm implementation was completely different: a lot of code has

changed from 2.x to 3.x.

#7 - 2018-11-22 03:35 PM - Andy Harfoot

Yes, dissolve appears to be a 'native' algorithm now, no python script available in 3.4

#8 - 2018-11-22 03:37 PM - Alessandro Pasotti

That explains the different behavior.

#9 - 2018-11-22 08:26 PM - Nyall Dawson
Even the older python dissolve tool used the geos library to dissolve. Your older 2.18.15 build will be using an earlier geos version, so | suspect that

something has changed within geos which is causing this error. Likely if you upgraded to 2.18.23, which will come with the newer geos library, you'll also

see this error.

#10 - 2018-11-23 09:22 AM - Alessandro Pasotti

The error is definitely in GEOS, I've been able to reproduce it in a GEOS test.

#11 - 2018-11-23 01:51 PM - Alessandro Pasotti

- Pull Request or Patch supplied changed from No to Yes

- Status changed from In Progress to Closed

- Resolution changed from up/downstream to fixed/implemented

Fixed in master and 3.4
Files
DissolveFail.zip 76.9 KB 2018-11-22 Andy Harfoot

Alessandro Pasotti

qgis-dissolve-error.png 238 KB 2018-11-22
qgis-dissolve-error-2.png 145 KB 2018-11-22 Alessandro Pasotti
